#! /usr/bin/ruby

# Copyright (C) 2010 Jérémy Pages.

# This file is part of Mnemochess.

# Mnemochess is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Mnemochess is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with Mnemochess.  If not, see <http://www.gnu.org/licenses/>.

require 'gtk2'

WHITE_PIECES = "KQRBNP"
BLACK_PIECES = "kqrbnp"

class Board < Gtk::DrawingArea
	def initialize
		super
		self.set_size_request(300,300)
		boardimage = Gtk::Image.new("../img/board.png")
		
		self.signal_connect("expose_event") do
			#self.window.draw_rectangle(self.style.fg_gc(self.state),false,100,50,60,45)
			self.window.draw_image(self.style.fg_gc(self.state),boardimage,0,0,30,30,-1,-1)
		end	
	end

	def set_from_array(pieceArray)
		for column in 0..7
			for rank in 0..7
				self.set_square(column,rank,pieceArray[column][rank])
			end
		end		 
	end

	def set_square(column,rank,piece)
		if WHITE_PIECES.include? piece
			filename = 'white'
		elsif BLACK_PIECES.include? piece
			filename = 'black'
		elsif piece == '.'
			#@squares[column][rank].clear
		end
		if WHITE_PIECES.include? piece or BLACK_PIECES.include? piece
			case piece.downcase
				when 'k'
					filename = filename + '_king.png'
				when 'q'
					filename = filename + '_queen.png'
				when 'r'
					filename = filename + '_rook.png'
				when 'b'
					filename = filename + '_bishop.png'
				when 'n'
					filename = filename + '_knight.png'
				when 'p'
					filename = filename + '_pawn.png'
			end
			filename = "../img/" + filename
			#@squares[column][rank].set_file('../img/' + filename)
			square = Gdk::Pixbuf.new(filename,30,30)
			@boardmap.draw_pixbuf(self.style.fg_gc(self.state),square,0,0,20,20,-1,-1,Gdk::RGB::DITHER_NORMAL,0,0)
			self.queue_draw
		end	
	end
end		
