#! /usr/bin/ruby

# Copyright (C) 2010 Jérémy Pages.
 
# This file is part of Mnemochess.
 
# Mnemochess is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
 
# Mnemochess is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
 
# You should have received a copy of the GNU General Public License
# along with Mnemochess.  If not, see <http://www.gnu.org/licenses/>.

DIGITS = "0123456789"
PIECES = "kqrbnpKQRBNP"

class Diagram
	attr_accessor :pieceArray	

	def initialize(fencode=nil)
		@pieceArray = Array.new(8) {|i| Array.new(8) {|j| '.'}}
		
		if fencode != nil
			ranks_strings = fencode.split('/')

			rank = 7
			for str in ranks_strings
				column = 0
				for char in str
					if DIGITS.include? char
						dist = char.ord - 48 
						column = column + dist
					else
						@pieceArray[column][rank] = char
						column = column+1
					end
				end
			rank = rank-1
			end
		end
	end

	def piece_number
		number = 0
		for column in 0..7
			for rank in 0..7
				if PIECES.include? @pieceArray[column][rank]
					number = number + 1
				end
			end
		end

		return number
	end

	def compare(other_diag)
		diffArray = Array.new(8) {|i| Array.new(8) {|j|}}
		for column in 0..7
			for rank in 0..7
				if @pieceArray[column][rank] == otherdiag.pieceArray[column][rank]
					if PIECES.include? @pieceArray[column][rank]
						diffArray[column][rank] = 1
					else
						diffArray[column][rank] = 0
					end
				else
					diffArray[column][rank] = -1
				end
			end
		end
		
		return diffArray
	end

	def set_square(column,rank,piece)
		@pieceArray[column][rank] = piece
	end
end 
