#! /usr/bin/ruby

# Copyright (C) 2010 Jérémy Pages.
 
# This file is part of Mnemochess.
 
# Mnemochess is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
 
# Mnemochess is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
 
# You should have received a copy of the GNU General Public License
# along with Mnemochess.  If not, see <http://www.gnu.org/licenses/>.

require 'diagram.rb'

CORRECT_PIECE = 4 # Points awarded for a right piece.
WRONG_PIECE   = 1	# Penalty for a wrong piece

class Game
	attr_accessor :leftDiagram, :rightDiagram, :time, :phase

	def initialize
		@leftDiagram = Diagram::new()
		@rightDiagram = Diagram::new()
		t = Time::now()
		@startTime = t.to_i
	end

	def score
		total = 0
		compArray = @leftDiagram.compare(@rightDiagram)
		for i in 0..7
			for j in 0..7
				case compArray[i][j]
					when 1
						total = total + CORRECT_PIECE
					when -1	
						total = total - WRONG_PIECE
				end
			end
		end
		
		return total
	end

	def choose_diag
		index = rand($diagArray.length)
		fencode = $diagArray[index]
		@leftDiagram = Diagram::new(fencode)
	end

	def second_phase 
		t = Time::now()
		@startTime = t.to_i
	end		

	def is_finished
	end 
end
